//
// tX  { |vO
//
// ͍\ ͕(̂Q)

#include "stdafx.h"
#include	<string.h>
#include	<ctype.h>

#include	"f2j.h"
#include	"myprot.h"

extern	TOKEN		*lastToken;
extern	TOKEN		*currentTree;
extern	ADVERB		dic_adverb_NE;
extern	BOOL		isChanged;
extern	PREPOSITION	dic_DeInf[];
extern	PREPOSITION	dic_among[];
extern	JP_PREPOSITION	dic_jpr_de[];
extern	FR_QUESTION	dic_Quel[];
extern  CMP_TOKEN	pat_QueDeFois[];

JP_PRONOUN	dic_JpPronoun_Leur[] = {
	JP_PRONOUN(
		FR_ATTRIB_ALL,	FR_ATTRIB_NONE,
		JP_PROP_ALL,	JP_PROP_NONE,
		NULL,
		"(//)",	JP_EMPHASIS_NONE,	FR_PART_NOUN_OBJECT_I,
		FR_ATTRIB_ILS,	JP_PROP_HUMAN,		JP_UNIT_NONE
	)
};

// ne le leur donnez pas.
PRONOUN	dic_pronoun_Leur = {
	"leur",
	FR_ATTRIB_ILS,	FR_SHORT_NONE,
	JPPRONOUN_DIC(dic_JpPronoun_Leur)
};


//
// Pass1ł͂킩Ȃiׂčl
//
void
ProcessSpecialWord1(TOKEN *start)
{
	TOKEN	*prev = start;
	TOKEN	*p = prev->next;

	while(p && !isChanged) {
		switch(p->frPart) {
		case FR_PART_SPECIAL_AUSSI:		Process_AUSSI(start, prev, p);		break;
		case FR_PART_SPECIAL_CE:		Process_CE(start, prev, p);			break;
		case FR_PART_SPECIAL_COMME:		Process_COMME(start, prev, p);		break;
//		case FR_PART_SPECIAL_D:			Process_D(start, prev, p);			break;
		case FR_PART_SPECIAL_DE:		Process_DE(start, prev, p);			break;
		case FR_PART_SPECIAL_GRACE:		Process_GRACE(start, prev, p);
		case FR_PART_SPECIAL_DES:		Process2_DES(start, prev, p);	break;
		case FR_PART_SPECIAL_EN:		Process_EN(start, prev, p);			break;
		case FR_PART_SPECIAL_EST:		Process_EST(p);						break;
		case FR_PART_SPECIAL_FOIS:		Process_FOIS(start, prev, p);		break;
		case FR_PART_SPECIAL_LA:		Process_LA(start, prev, p);			break;
		case FR_PART_SPECIAL_LEUR:		Process_LEUR(start, prev, p);		break;
		case FR_PART_SPECIAL_LEQUEL:	Process_LEQUEL(start, prev, p);		break;
		case FR_PART_SPECIAL_MEME:		Process_MEME(start, prev, p);		break;
		case FR_PART_SPECIAL_MOINS:		Process_MOINS(start, prev, p);		break;
		case FR_PART_SPECIAL_NI:		Process_NI(start, prev, p);			break;
		case FR_PART_SPECIAL_NIMPORTE:	Process_NIMPORTE(start, prev, p);	break;
		case FR_PART_SPECIAL_PEU:		Process_PEU(start, prev, p);		break;
		case FR_PART_SPECIAL_QUAND:		Process_QUAND(start, p);			break;
		case FR_PART_SPECIAL_QUI:		Process_QUI(start, prev, p);		break;
		case FR_PART_SPECIAL_QUOI:		Process_QUOI(start, prev, p);		break;
		case FR_PART_SPECIAL_QUE:		Process_QUE(start, prev, p);		break;
		case FR_PART_SPECIAL_OU:		Process_OU(start, prev, p);			break;
		case FR_PART_SPECIAL_PLUS:		Process_PLUS(start, prev, p);		break;
		case FR_PART_SPECIAL_COMMA:		Process_COMMA(start, prev, p);		break;
		case FR_PART_SPECIAL_S:			Process_S(start, p);				break;
		case FR_PART_SPECIAL_SI:		Process_SI(start, p);				break;
		case FR_PART_SPECIAL_SEULEMENT:Process_SEULEMENT(start, p);		break;
		case FR_PART_SPECIAL_TOUT:		Process_TOUT(start, prev, p);		break;
		}
		prev = p;
		p = p->next;
	}
}

CMP_TOKEN	patAussi1[] = {
	// j'ai aussi voiture.
//	CMP_TOKEN( FR_PART_NOUN_ALL,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_VERB_UNCLEAR,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_SPECIAL_AUSSI,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NONE)
};

//
// "aussi"
//  
void
Process_AUSSI(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(IsObjectMatch(prev, FR_PART_SENTENCE_ALL)) {
		DisconnectTOKEN(start, p);
		if(prev->object1) {
			TOKEN	*subject = prev->object1;
			subject->jpEmphasis |= JP_EMPHASIS_MO;
		}
		return;
	}
	if(IsPatternMatch(patAussi1, prev)) {
		DisconnectTOKEN(start, p);
		prev->jpEmphasis |= JP_EMPHASIS_MO;
		return;
	}
	// je vais aussi (en Italie et en Espagne).
	if(next
	&& (next->frPart & FR_PART_COMBINE)) {
		DisconnectTOKEN(start, p);
		next->jpEmphasis |= JP_EMPHASIS_MO;
	}
}


//
// 'ce'
// 㖼Aw`e
//
void
Process_CE(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if((prev->frPart & FR_PART_VERB) && prev->punctuation == FR_PUNCT_HYPHEN) {
		// quelle fleur est-<ce> ?
		ChangeToPronoun(p, "ce");
		return;
	}

	if(next == NULL)	return;

	if(next->frPart & FR_PART_VERB) {
		ChangeToPronoun(p, "ce");
	} else if((next->frPart & FR_PART_ADJECTIVE)
			|| (next->frPart & FR_PART_NOUN)) {
		// w`e
		ChangeToProadjective(p, "ce");
	} else if(next->frPart == FR_PART_SPECIAL_QUE
			|| next->frPart == FR_PART_SPECIAL_QUOI) {
		// vous ferez <ce> que je vous dis.
		ChangeToPronoun(p, "ce");
		next->frPart = FR_PART_RELATIVE_OBJECT_N;
	} else if(next->frPart == FR_PART_SPECIAL_QUI) {
		// ce qui n'est pas clair n'est pas fran\ais.
		ChangeToPronoun(p, "ce");
//		next->frPart = FR_PART_RELATIVE_SUBJECT;
	}
}

//
// ','
// 
void
Process_COMMA(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(next == NULL)	return;

	if(IsObjectMatch(prev, FR_PART_INDEPENDENCE_INTERJECTION)) {
		ChangeToCombine(p, ",");
		p->frPart = FR_PART_COMBINE_VERB;
#if 1
	} else if((prev->frPart & FR_PART_COMBINE)
		&& prev->object2 == NULL) {
		// Mais, o| est les neiges d'antan?
		DisconnectTOKEN(start, p);
		next->punctuation = FR_PUNCT_COMMA;
	} else if((next->frPart & FR_PART_COMBINE)
		&& next->object1 == NULL) {
		if(next->object2 != NULL) {
			// , mais SV,	, car SV
			DisconnectTOKEN(start, p);
			next->punctuation = FR_PUNCT_COMMA;
		}
#endif
#if 1
	// ProcessCombine1, ProcessCombine2Ƃقړl
	// AAFR_PART_COMBINE_GENERALɕύXƁA
	// ̕A₪ȂĂ܂̂ŁAOŏ
	} else if(SearchToken(FR_PART_VERB, start, p)
		&& (p->frPartChoice & FR_PART_VERB)
		&& IsObjectMatch(next, FR_PART_VERB_ALL)) {
			// ͓młAȂꍇ eg) d{s qu'il fut arriv{, elle sortit.
			CopyCurrentTree(p, "Comma-1", FR_PART_VERB);
			ChangeToCombine(p, ",");
			p->frPart = FR_PART_COMBINE_VERB;
			// FR_PART_VERB̘ÁAFR_PART_SENTENCE_NO_SUBJECTĂAs
	} else if(IsObjectMatch(prev, FR_PART_NOUN_ALL)
		&& (p->frPartChoice & FR_PART_NOUN)
		&& IsObjectMatch(next, FR_PART_NOUN_ALL)) {
		CopyCurrentTree(p, "Comma 1", FR_PART_NOUN);
		ChangeToCombine(p, ",");
		p->frPart = FR_PART_COMBINE_NOUN;
	} else if(IsObjectMatch(prev, FR_PART_ADJECTIVE_ALL)
		&& (p->frPartChoice & FR_PART_ADJECTIVE)
		&& IsObjectMatch(next, FR_PART_ADJECTIVE_ALL)) {
			CopyCurrentTree(p, "Comma 2", FR_PART_ADJECTIVE);
			ChangeToCombine(p, ",");
			p->frPart = FR_PART_COMBINE_ADJECTIVE;
	} else if(IsObjectMatch(prev, FR_PART_ADVERB_ALL)
		&& (p->frPartChoice & FR_PART_ADVERB)
		&& IsObjectMatch(next, FR_PART_ADVERB_ALL)) {
			CopyCurrentTree(p, "Comma 3", FR_PART_ADVERB);
			ChangeToCombine(p, ",");
			p->frPart = FR_PART_COMBINE_ADJECTIVE;	// FR_PART_COMBINE_ADVERB͂Ȃ
	} else if(SearchToken(FR_PART_PREPOSIT, start, p)
		&& (p->frPartChoice & FR_PART_PREPOSIT)
		&& IsObjectMatch(next, FR_PART_PREPOSIT)) {
			CopyCurrentTree(p, "Comma 4", FR_PART_PREPOSIT);
			ChangeToCombine(p, ",");
			p->frPart = FR_PART_COMBINE_PREPOSIT;
#endif
	}
}

//
// 'comme'
// ڑAiQjAOu
//
void
Process_COMME(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(next == NULL)	return;

	if((SearchToken(FR_PART_VERB_ALL, p->next))
	&& (currentTree->punctuation & FR_PUNCT_EXCLAMINATION)) {
		TOKEN *altP = CopyCurrentTree(p, "Comme 2", FR_PART_ADVERB);
		ChangeToProadverb(altP, "comme");
	}
	// `ƂāA	elle est excellente comme secr{taire.
	// `̂悤
//	TOKEN	*altP = CopyCurrentTree(p, "Comme 3", FR_PART_PREPOSIT);
	ChangeToPreposition(p, "comme");
}


CMP_TOKEN	pat_AdjDeNoun[] = {
	// eloigne de la plage.
	CMP_TOKEN( (FR_PART)(FR_PART_ADVERB_ALL | FR_PART_ADJECTIVE_ALL),	JP_PROP_PLACE,	NULL),
	CMP_TOKEN( FR_PART_SPECIAL_DE,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NOUN_ALL,		JP_PROP_PLACE,	NULL),
	CMP_TOKEN( FR_PART_NONE)
};

CMP_TOKEN	pat_NounDePlus1[] = {
	// il a deux ans de plus que moi.
	CMP_TOKEN( FR_PART_NOUN_ALL,		JP_PROP_UNIT,	NULL),
	CMP_TOKEN( FR_PART_SPECIAL_DE,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_SPECIAL_PLUS,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NONE)
};

CMP_TOKEN	pat_NounDePlus2[] = {
	// chose de meilleur.
	CMP_TOKEN( FR_PART_NOUN_ALL,		JP_PROP_UNIT,	NULL),
	CMP_TOKEN( FR_PART_SPECIAL_DE,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( (FR_PART)(FR_PART_ADJECTIVE_ALL | FR_PART_ADVERB_ALL),	JP_PROP_NONE,	IsCompare),
	CMP_TOKEN( FR_PART_NONE)
};

CMP_TOKEN	pat_NePasDuTout[] = {
	// il n'est pas du tout malade.
	CMP_TOKEN( FR_PART_SPECIAL_DE,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_ARTICLE_DEFINIT,JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_SPECIAL_TOUT,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NONE)
};

BOOL
IsNotSubject(TOKEN *p)
{
	// Venez-(vous <de> Paris)? ()h
	if(!IsObjectMatch(p, FR_PART_NOUN_SUBJECT))
		return(TRUE);

	return(FALSE);
}

CMP_TOKEN	pat_PNounDeNoun1[] = {
	// celui de votre fr}re.
	CMP_TOKEN((FR_PART)(FR_PART_NOUN_DEMONSTRATIVE | FR_PART_NOUN_OBJECT_BOTH | FR_PART_NOUN_INDEFINIT),
		JP_PROP_NONE,	IsNotSubject),
	CMP_TOKEN( FR_PART_SPECIAL_DE,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NOUN_ALL,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NONE)
};

JP_COMBINE	jpCombineDeSortQue[] = {
	JP_COMBINE("%s1BŁA%s2",	FR_PART_NONE,
		FR_PART_SENTENCE_NORMAL,JP_PROP_NONE,
		FR_PART_SENTENCE_ALL,	JP_PROP_NONE
	),
};
COMBINE	combineDeSortQue =
{
	"de sort que",	FALSE,	FR_PART_COMBINE_VERB,	JPCOMBINE_DIC(jpCombineDeSortQue)
};


CMP_TOKEN	pat_DeSorteQue[] = {
	// elle n'est pas venue, de sorte que nous avons d~ changer notre projet.
	CMP_TOKEN( FR_PART_SPECIAL_DE,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NOUN_GENERAL,	"sorte"),
	CMP_TOKEN( FR_PART_SPECIAL_QUE,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NONE)
};


// D'Autre
JP_PRONOUN	dic_De_Autre[] = {
	JP_PRONOUN( 	FR_ATTRIB_ALL,	FR_ATTRIB_NONE,
		JP_PROP_ALL,	JP_PROP_NONE,
		NULL,
		"̐l",		JP_EMPHASIS_NONE,	FR_PART_NOUN_INDEFINIT,
		FR_ATTRIB_ILS,	JP_PROP_HUMAN,		JP_UNIT_NONE
	)
};
PRONOUN	pronounDe_Autre = {
	"de autre",	FR_ATTRIB_JE,	FR_SHORT_NONE,		JPPRONOUN_DIC(dic_De_Autre)
};

//
// 'de'
// s芥AAOu(inf𓱂)A`eƂȂAے芥
void
Process_DE(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(next == NULL)	return;

	if(IsPatternMatch(pat_NounDePlus1, prev)) {
		DisconnectTOKEN(start, p->next);	// "plus"폜
		DisconnectTOKEN(start, p);			// "de"폜
		prev->frAttrib = (FR_ATTRIB)(prev->frAttrib | FR_ATTRIB_PLUS);
		return;
	} 
	if(IsPatternMatch(pat_NounDePlus2, prev)) {
		TOKEN	*adj = p->next;
		DisconnectTOKEN(start, adj);		// "meilleur"폜
		DisconnectTOKEN(start, p);			// "de"폜
		AddChildTOKEN(prev, adj);
		return;
	}
	if((prev->jpProp & JP_PROP_NEGATIVE)
	&& IsPatternMatch(pat_NePasDuTout, p)) {	// il n'est pas du tout malade.
		ChangeToAdverb(next->next, "tout");
		DisconnectTOKEN(start, next);	// "de"폜	du = de + le
		DisconnectTOKEN(start, p);	// "le"폜		du = de + le
		return;
	}
	if(IsPatternMatch(pat_PNounDeNoun1, prev)) {		// celui de votre fr}re.
		ChangeToPreposition(p, "de");
		p->frPartParent = FR_PART_NOUN;
		return;
	}
	if(IsPatternMatch(pat_DeSorteQue, p)) {		// de sorte que
		ChangeToCombine(p, &combineDeSortQue);
		DisconnectTOKEN(start, p->next->next);	// "que"폜
		DisconnectTOKEN(start, p->next);	// "sorte"폜
		return;
	}
	if(IsObjectMatch(next, FR_PART_ADJECTIVE_ALL, JP_PROP_NONE, NULL, "autre")	// D'autre
	&& (next->next == NULL || !(next->next->frPart & FR_PART_NOUN))) {
		ChangeToPronoun(next, &pronounDe_Autre);
		DisconnectTOKEN(start, p);			// "de"폜
		return;
	}

	// s莌𓱂Ou
	if((next->frPart & FR_PART_VERB)
	&& (next->frTense & FR_TENSE_ORIGIN)) {
		ChangeToPreposition(p, dic_DeInf);
		return;
	}
	// i, des + `e + Aے芥j
	if((!(prev->frPart & FR_PART_NOUN) || (prev->frPart & FR_PART_COMBINE))
	&& (p->frPartChoice & FR_PART_ARTICLE)
	&& IsObjectMatch(next, FR_PART_NOUN_ALL)) {
		p->frPartChoice = (FR_PART)(p->frPartChoice & ~FR_PART_ARTICLE);
		if(ProcessArticleDe(start, p, next))	return;
	}
	if(((prev->frPart & FR_PART_COMBINE) || !(prev->frPart & FR_PART_PREPOSIT))
	&& (p->frPartChoice & FR_PART_PREPOSIT)) {
		// Oủ\
		if(IsPatternMatch(pat_AdjDeNoun, prev)) {
			ChangeToPreposition(p, "de");
		} else if(! SearchToken(FR_PART_SPECIAL_DE, p->next)) {
			// 납͂ eg) la maison de (frere de Marie).
			ProcessPrepositionDe(start, prev, p, next);
		}
	}
}

//
// ƂĂ"de"
// , des + `e + Aے芥
//
BOOL
ProcessArticleDe(TOKEN *start, TOKEN *p, TOKEN *noun)
{
	TOKEN *article = SearchToken(FR_PART_ARTICLE_DEFINIT, noun->child);

	if(!IsObjectMatch(noun, FR_PART_NOUN_GENERAL))
		return(FALSE);

	if(!(noun->frAttrib & FR_ATTRIB_PLURAL)	// de + les͂Ȃ
	&& article
	&& !SearchToken(FR_PART_ARTICLE_PARTIAL, noun->child)
	&& !SearchToken(FR_PART_ARTICLE_INFINIT, noun->child)) {
		// 
		if(!(noun->jpProp & JP_PROP_PARTIAL))	// ⓚp
			MakeOtherChoiceDe(p, FR_PART_ARTICLE, "De 1");
		ChangeToArticle(article, "de");
		article->frPart = FR_PART_ARTICLE_PARTIAL;
//		p->frAttrib = next->frAttrib;
		DisconnectTOKEN(start, p);	// de + la -> ̒PƂĈ
	} else if((noun->frAttrib & FR_ATTRIB_PLURAL)
		&& SearchToken(FR_PART_ADJECTIVE_GENERAL_F, noun->child)
		&& SearchToken(FR_PART_ADJECTIVE_POSSESIVE, noun->child) == NULL	// L`e͎͊gȂ
		&& SearchToken(FR_PART_ARTICLE_ALL, noun->child) == NULL) {
		// des petites revues -> <de> petites revues.
		MakeOtherChoiceDe(p, FR_PART_ARTICLE, "De 2");
		ChangeToArticle(p, "des");
	} else if(SearchNegativeToken(start, p)
		&& SearchToken(FR_PART_ARTICLE_ALL, noun->child) == NULL) {
		// ے芥
		MakeOtherChoiceDe(p, FR_PART_ARTICLE, "De 3");
		ChangeToArticle(p, "de");
		p->frPart = FR_PART_ARTICLE_NEGATIVE;
	} else
		return(FALSE);

	return(TRUE);
}

//
// OuƂĂ"de"
// , des + `e + Aے芥
//
BOOL
ProcessPrepositionDe(TOKEN *start, TOKEN *prev, TOKEN *p, TOKEN *next)
{
	static TOKEN	dummy;

	BOOL	savIsChanged = isChanged;
	ChangeToPreposition(&dummy, "de");	// ɑウĂ݂
	if(MatchPrepositionObject(&dummy, next) == NULL) {
		isChanged = savIsChanged;	// ʖڂAɖ߂B
		return(FALSE);
	}

	TOKEN *altP = MakeOtherChoiceDe(p, FR_PART_PREPOSIT, "De 5");

	ChangeToPreposition(p, "de");

	// ŏʔr<de>?
	if(IsWordOwner(prev, (FR_ATTRIB)(FR_ATTRIB_TOP | FR_ATTRIB_ONE_OF))
	&& SearchToken(FR_PART_PREPOSIT_DE_AMONG, prev->child) == NULL) {
		for(TOKEN *q = start; q; q = q->next) {
			if(q->frPart == FR_PART_PREPOSIT_DE_AMONG)	break;
		}
		if(q == NULL)
			ChangeToPreposition(p, dic_among);
	}
	return(TRUE);
}

//
// "De"̕ʌTreeKvȂ쐬
//
TOKEN
*MakeOtherChoiceDe(TOKEN *p, FR_PART mask, char *s)
{
	FR_PART	choice = (FR_PART)(p->frPartChoice & ~mask);
	if((choice & FR_PART_ARTICLE)
	|| (choice & FR_PART_PREPOSIT)) {
		TOKEN *altP = CopyCurrentTree(p, s);
		altP->frPartChoice = choice;
		return(altP);
	}
	return(NULL);
}

TOKEN
*SearchNegativeToken(TOKEN *start, TOKEN *end)
{
	TOKEN	*p;

	for(p = start; p && p != end; p = p->next) {
		if(p->jpProp & JP_PROP_NEGATIVE)	return(p);
	}
	return(NULL);
}

static JP_PREPOSITION	jp_GraceA[] = {
	JP_PREPOSITION(	"%1N",	JP_KIND_RENTAISHI,
		JP_PROP_CONDITION,
		CMP_TOKEN ( FR_PART_SENTENCE_ALL),
		CMP_TOKEN ( FR_PART_NOUN_ALL)
	),
};

PREPOSITION fr_GraceA[] = {
	{ "gr`ce_A",	FR_PART_PREPOSIT_GRACE_A,	JPPREPOSIT_DIC(jp_GraceA)		},
};

//
// 'grace'
// AOu(Grance a ` `̂)
void
Process_GRACE(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(next
	&& next->frPart == FR_PART_PREPOSIT_A) {
		ChangeToPreposition(p, fr_GraceA);
		DisconnectTOKEN(start, next);
	} else {
		ChangeToNoun(p, "gr@ce");
	}
}

//
// 'l@'
// Auw`ei voiture-l@j
void
Process_LA(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	if(p->next
	&& (p->punctuation & FR_PUNCT_HYPHEN)
	&& IsTokenFrench(p->next, "bas")) {
		// l@-basH
		ChangeToAdverb(p, "l@-bas");
		DisconnectTOKEN(start, p->next);
	} else if(prev
	&& IsObjectMatch(prev, (FR_PART)(FR_PART_NOUN_GENERAL | FR_PART_NOUN_DEMONSTRATIVE))
	&& (prev->punctuation & FR_PUNCT_HYPHEN)) {
		ChangeToProadjective(p, "l@");
	} else if(p->punctuation & FR_PUNCT_HYPHEN) {
		currentTree->prtControl = PRT_CONTROL_DISABLE;
	}else {
		ChangeToAdverb(p, "l@");
	}
};

//
// 'leur'
// L`eAԐږړI㖼
void
Process_LEUR(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(next == NULL)	return;

	// L`e
	if(next->frPart & FR_PART_NOUN) {
		ChangeToProadjective(p, "leur");
		AttachAdjective(start, next, p, FR_LOCATION_FRONT);
		return;
	}
	// ԐږړI㖼
	if(IsObjectMatch(next, FR_PART_VERB_UNCLEAR)
	||  next->frPart == FR_PART_ADVERB_Y
	||  next->frPart == FR_PART_SPECIAL_EN) {
		ChangeToPronoun(p, &dic_pronoun_Leur);
		return;
	}
	PrintInternalError( "<leur>͂܂[\n");
}

//
// 'lequel'
// ڑ
void
Process_LEQUEL(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	if(start == prev				// 擪ɂƂƂ́A^㖼Ɋm
	|| IsObjectMatch(prev, FR_PART_SPECIAL_COMMA)) {	// Quand vous parle de ces hommes, duquel parlez-vous?
		ChangeToQuestion(p, ((SPECIALWORD *)p->what)->french);
		return;
	}

	if((prev->frPart & FR_PART_NOUN)
	&& p->preposition) {
		p->frPart = FR_PART_RELATIVE_OBJECT_N;
		// iłȂ̂ŁAKɎꂪKv eg) adresse auxquelles vous {crirez.
		if(p->next && IsObjectMatch(p->next, FR_PART_NOUN_OBJECT_BOTH)) {
			p->next->frPart = (FR_PART)(p->next->frPart & ~FR_PART_NOUN_OBJECT_BOTH);
			p->next->frPart = (FR_PART)(p->next->frPart | FR_PART_NOUN);
		}
		isChanged = TRUE;
	}
}

//
// 'moins'
// plus S+V, <moins> S+V
// (ŕACombinePlusAdjectiveŏĂ)
//
void
Process_MOINS(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	// Il l'est moins.
	if(next == NULL) {
		ChangeToAdverb(p, "moins");
		return;
	}

	if( next
	&& IsObjectMatch(next,  FR_PART_SENTENCE_ALL)) {
		// plus S+V, <moins> S+V
		ChangeToAdverb(p, "moins");
		return;
	}
}


//
// 'memel'
// `eA㖼A
void
Process_MEME(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	if(IsObjectMatch(prev, FR_PART_NOUN_PERSONAL)
	&& (prev->punctuation & FR_PUNCT_HYPHEN)) {
		// moi-memes g
		DisconnectTOKEN(start, p);
		prev->jpEmphasis = JP_EMPHASIS__MEME;
		return;
	}
	if(IsObjectMatch(prev, FR_PART_NOUN_ALL)) {
		// `łA
		// ses ennemis m]mes ne pouvaient lui refuser du talent.
		DisconnectTOKEN(start, p);
		prev->jpEmphasis = JP_EMPHASIS_MEME;
		return;
	}
	if(p->next
	&& IsObjectMatch(p->next, FR_PART_NOUN_ALL)) {
		ChangeToAdjective(p, *(char **)p->what);
		return;
	}
	// s芥̌́As㖼
	//	Ils restent les m]mes.
	if(IsObjectMatch(prev, FR_PART_ARTICLE_DEFINIT)) {
		ChangeToPronoun(p, "m]me");
		DisconnectTOKEN(start, p);
		return;
	}

	if(p->frAttrib & FR_ATTRIB_SINGLE)
		ChangeToAdverb(p, "m]me");
}

//
// 'ni'
// je n'ai <ni> p}re <ni> m}re.
//              ڑ

void
Process_NI(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	if(p
	&& p->next
	&& p->next->next
	&& p->next->next->frPart == FR_PART_SPECIAL_NI) {
		TOKEN *ni2 = p->next->next;
		p->next->jpEmphasis |= JP_EMPHASIS_NI;
		ni2->next->jpEmphasis |= JP_EMPHASIS_NI;
		ChangeToCombine(ni2, "ni");
		DisconnectTOKEN(start, p);
	} else if((prev->frPart & FR_PART_NOUN)
		&& p->next) {
		ChangeToCombine(p, "ni");
		p->frPart = FR_PART_COMBINE_NOUN;
		prev->jpEmphasis |= JP_EMPHASIS_NI;
		p->next->jpEmphasis |= JP_EMPHASIS_NI;
	} else if((prev->frPart & FR_PART_ADJECTIVE)
		&& p->next) {
		ChangeToCombine(p, "ni");
		p->frPart = FR_PART_COMBINE_ADJECTIVE;
		prev->jpEmphasis |= JP_EMPHASIS_NI;
		p->next->jpEmphasis |= JP_EMPHASIS_NI;
	}
}



	
static	JP_PROADJECTIVE	jpadj_NImporteQuel[] = {
	JP_PROADJECTIVE(
		FR_PART_ADJECTIVE_DEMONSTRATIVE,
		"ǂ",		JP_KIND_NONE,
		JP_PROP_CONDITION)
};

PROADJECTIVE	proadjN_IMPORTE_QUELLE[] = {
	{ "n'importe quel",		FR_ATTRIB_NONE,	FR_CHANGE_NONE, JPPROADJ_DIC(jpadj_NImporteQuel)	},
};

static JP_PRONOUN	jpnn_NImporteQuel[] = {
	JP_PRONOUN( 	FR_ATTRIB_ALL,	FR_ATTRIB_NONE,
		JP_PROP_ALL,	JP_PROP_NONE,
		NULL,
		"",		JP_EMPHASIS_DEMO,	FR_PART_NOUN_INDEFINIT,
		FR_ATTRIB_NONE,	JP_PROP_THING,	JP_UNIT_NONE
	)
};

PRONOUN			pronounN_IMPORTE_QUOI[] = {
	{ "n'importe quoi",		FR_ATTRIB_NONE,	FR_SHORT_NONE, JPPRONOUN_DIC(jpnn_NImporteQuel)	},
};

static JP_ADVERB jpadvN_IMPORTE_OU[] = {
	JP_ADVERB("ǂł",	JP_KIND_NONE,	JP_PROP_PLACE,	JP_PROP_ALL)
};

ADVERB	advN_IMPORTE_OU[] = {
	"n'importe o|",	JPADVERB_DIC(jpadvN_IMPORTE_OU),	NULL,	NULL
};

//
// 'n'importe'
//
void
Process_NIMPORTE(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(next == NULL)	return;

	FR_ATTRIB	frAttrib = next->frAttrib;
	char	*str = GetTokenFrench(next);

	if(!strcmp(str, "quel")
	|| !strcmp(str, "quelle")
	|| !strcmp(str, "quels")
	|| !strcmp(str, "quelles")) {
		ChangeToProadjective(p, proadjN_IMPORTE_QUELLE);
		TOKEN *noun = SearchToken(FR_PART_NOUN_GENERAL, next);
		if(noun)
			noun->jpEmphasis |= JP_EMPHASIS_DEMO;
	} else if(next->frPart == FR_PART_SPECIAL_QUOI) {
		ChangeToPronoun(p, pronounN_IMPORTE_QUOI);
	} else if(next->frPart == FR_PART_SPECIAL_OU) {
		ChangeToAdverb(p, advN_IMPORTE_OU);
	} else
		return;

	DisconnectTOKEN(start, next);
	p->frAttrib = frAttrib;
}

//
// 'en'
// OuAen + WFfBt
// 㖼̏ProcessObjectPronounōs
void
Process_EN(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(next == NULL)	return;

	// en + ݕ -> WFfBt
	if((next->frPart & FR_PART_VERB)
	&& (next->frTense & FR_TENSE_P_PRESENT)) {
		ChangeToPreposition(p, "en");
		p->frPart = FR_PART_PREPOSIT_EN_ENT;	// gerondif
	}
	if(IsObjectMatch(next, FR_PART_NOUN_ALL)
	|| IsObjectMatch(next, FR_PART_NUMETRIC_ALL)	// en 1998.
	|| next->frPart == FR_PART_SPECIAL_QUI
	|| next->frPart == FR_PART_SPECIAL_QUE
	|| next->frPart == FR_PART_SPECIAL_QUOI) {	// Ou
		ChangeToPreposition(p, "en");
	}
}

//
//
//
void
Process_EST(TOKEN *p)
{
	ChangeToVerb(p, "]tre");
	p->frAttrib = FR_ATTRIB_IL;
	p->frTense = FR_TENSE_PRESENT;
}

//
// "FOIS"
// A{{r
//
void
Process_FOIS(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(next == NULL)	return;

	if(IsObjectMatch(prev, FR_PART_NUMETRIC_NUMBER)
	&& (next->frAttrib & (FR_ATTRIB)(FR_ATTRIB_PLUS	|FR_ATTRIB_MOINS))) {
		ChangeToProadverb(p, "fois");
		next->value  = prev->value;
		DisconnectTOKEN(start, prev);
		DisconnectTOKEN(start, p);
	} else {
		ChangeToNoun(p, "fois");
	}
	isChanged = TRUE;
}

//
// 'peu'̏
// un peu -> 
// peu -> قƂǁ`Ȃ
void
Process_PEU(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	if(prev->frPart == FR_PART_NUMETRIC_NUMBER
	&& prev->value == 1) {	// "un"H		GetTokenFrench͎gȂ
		DisconnectTOKEN(start, prev);
		ChangeToAdverb(p, "peu");	// ChangeToProadverb(p, dic_UnPeu);
	} else {
		if( p->next
		&& FlipAdjective(p->next)) {
			DisconnectTOKEN(start, p);
		} else {
			ChangeToAdverb(p, "peu");	// ChangeToProadverb(p, dic_Peu);
			p->jpProp |= JP_PROP_NEGATIVE;
		}
	}
}

//
// 'quand'
// ^㖼Aڑ
//  vous ]tes @ Paris depuis quand? ̂悤Ɉʒuł͔ʂłȂ
// ł́AlɤQ̉\WJ
void
Process_QUAND(TOKEN *start, TOKEN *p)
{
	TOKEN	*altP = CopyCurrentTree(p, "Special Quand");

	ChangeToQuestion(p, "quand");
	ChangeToPreposition(altP, "quand");
	isChanged = TRUE;
}

CMP_TOKEN	pat_QuiDesNum[] = {
	// on ne sait pas @ qui des deux s'adresser.
	CMP_TOKEN( FR_PART_SPECIAL_QUI,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_SPECIAL_DES,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NUMETRIC_NUMBER,JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NONE)
};

//
// 'qui'
// ^㖼A֌W㖼
void
Process_QUI(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(p->frPartChoice & FR_PART_INTERROGATIVE) {
		if(start == prev) {	// 擪ɂƂƂ́A^㖼H
			isChanged = TRUE;
			ChangeToQuestion(p, "qui");
			return;
		}
		if(IsPatternMatch(pat_QuiDesNum, p)) {		// qui des deux -> l̂N
			TOKEN	*num = p->next->next;
			DisconnectTOKEN(start, p->next);
			DisconnectTOKEN(start, num);
			AddChildTOKEN(p, num);
			ChangeToQuestion(p, "qui");
			num->frPart = FR_PART_NUMETRIC_CHOICE;
			num->jpUnit = p->jpUnit;
			return;
		}
		// ړI㖼΂	eg) je ne sais @ qui des deux s'addresser.
		TOKEN	*verb = SearchToken(FR_PART_VERB_UNCLEAR, next);
		if( verb
		&& (verb->frTense & FR_TENSE_ORIGIN)) {
		// je ne sais que faire. `Ɨ
			TOKEN	*altP = CopyCurrentTree(p, "Qui 1");
			ChangeToQuestion(altP, "qui");
			p->frPartChoice = (FR_PART)(p->frPartChoice & ~FR_PART_INTERROGATIVE);
		}
	}

	if(next == NULL)	return;

	if((prev->frPart & FR_PART_NOUN)
	&& (next->frPart & FR_PART_VERB)
	&&  next->which) {			// ֌W㖼
		p->frPart = FR_PART_RELATIVE_SUBJECT;
		DisconnectTOKEN(start, p);
		DisconnectTOKEN(start, next);
		SelectJpVerb2(prev, next);
		p->object1 = next;
		AddChildTOKEN(prev, p);
	}
	if( p->preposition			// la dame @ qui il parle.
	&& (prev->frPart & FR_PART_NOUN)
	&& (next->frPart & FR_PART_NOUN)
	&&  next->next
	&& (next->next->frPart & FR_PART_VERB)) {
		p->frPart = FR_PART_RELATIVE_OBJECT_N;
		isChanged = TRUE;
	}
}

//
// 'quoi'
// ^㖼A֌W㖼
void
Process_QUOI(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(start == prev) {
		// 擪ɂƂƂ́A^㖼H
		ChangeToQuestion(p, "quoi");
		return;
	}

	if(next == NULL)	return;

	if( p->preposition
	&&  p->preposition->frPart == FR_PART_PREPOSIT_DE	// de quoi manger. Hׂ
	&&  next
	&& IsObjectMatch(next, FR_PART_VERB_UNCLEAR)
	&& next->frTense == FR_TENSE_ORIGIN) {
		TOKEN	*noun = PutNullNoun(), *subject = PutNullNoun();
		noun->prtControl = PRT_CONTROL_ENABLE;
		ChangeToPronoun(noun, "ce");
		noun->jpProp = JP_PROP_THING;
		ChangeToPronoun(subject, "on");
		InsertTOKEN(prev, noun);
		InsertTOKEN(p, subject);
		p->frPart = FR_PART_RELATIVE_OBJECT_N;
		return;
	}

	if((prev->frPart & FR_PART_NOUN)
	&& (next->frPart & FR_PART_VERB)) {		// ֌W㖼
		if(next->which == NULL) {
			SelectJpVerb1(next);
			if(next->which == NULL)	return;
		}
		p->frPart = FR_PART_RELATIVE_SUBJECT;
		DisconnectTOKEN(start, p);
		DisconnectTOKEN(start, next);
		p->object2 = next;
		AddChildTOKEN(prev, p);
		return;
	}
	if( p->preposition			// ce @ quoi je pense.
	&& (next->frPart & FR_PART_NOUN)
	&&  next->next
	&& IsObjectMatch(next->next, FR_PART_VERB_UNCLEAR)) {
		if(!IsObjectMatch(prev, FR_PART_NOUN_DEMONSTRATIVE)) {
			// C'est <ce> @ quoi je pense.
			TOKEN	*noun = PutNullNoun();
			noun->prtControl = PRT_CONTROL_ENABLE;
			ChangeToPronoun(noun, "ce");
			InsertTOKEN(prev, noun);
		}
		p->frPart = FR_PART_RELATIVE_OBJECT_N;
		isChanged = TRUE;
		return;
	}
}

//
// 'que'
// ^㖼ڑ, r(`)
//
void
Process_QUE(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(prev->frPart == FR_PART_INTERROGATIVE_UNCLEAR) {
		// Combien que de d{fauts il a! ->Q
		return;
	}

	// Jacques est plus actif <que> Louise. `
	TOKEN	*lastCmp = NULL;	// rp
	for(TOKEN *q = start; q && q != p; q = q->next) {
		TOKEN *cmp = IsWordOwner(q, FR_ATTRIB_COMPARE);
		if(cmp)	lastCmp = cmp;	// ԍŌ̔r
	}
	if(lastCmp
	&& (p->frPartChoice & FR_PART_CONJUNCTION)) {
		CopyCurrentTree(p, "Que 2", FR_PART_CONJUNCTION);
		p->frPart = FR_PART_CONJUNCTION_THAN;
		return;
	}

	if(p->frPartChoice & FR_PART_INTERROGATIVE) {
		// 擪ɂƂƂ́A^㖼H
		if((start == prev || prev->frPart == FR_PART_SPECIAL_COMMA)
		// 擪ɂĂ eg) Qu'il parte imm{diatement!
		&& (currentTree->punctuation & FR_PUNCT_QUESTION)) {
			ChangeToQuestion(p, "que");
			return;
		}
		// ړI㖼΂	eg) je ne sais que <lui> r{pondre.	
		TOKEN	*verb = SearchToken(FR_PART_VERB_UNCLEAR, next);
		if( verb
		&& (verb->frTense & FR_TENSE_ORIGIN)) {
		// je ne sais que faire. `Ɨ
			TOKEN	*altP = CopyCurrentTree(p, "Que 3");
			ChangeToQuestion(altP, "que");
			p->frPartChoice = (FR_PART)(p->frPartChoice & ~FR_PART_INTERROGATIVE);
		}
	}

	// ne ... que `  `
/*	if( prev
	&& (prev->frPart & FR_PART_VERB)
*/
	if( SearchToken(JP_PROP_NEGATIVE, start, p)
	&&  next
	&& (next->frPart & (FR_PART)(FR_PART_NOUN | FR_PART_PREPOSIT))
	&& (p->frPartChoice & FR_PART_ADVERB)) {
		CopyCurrentTree(p, "Que 4", FR_PART_ADVERB);
		next->jpEmphasis |= JP_EMPHASIS_ONLY;
		DisconnectTOKEN(start, p);
		return;
	}

	if(((prev->frPart & FR_PART_NOUN)
	|| ((prev->frPart & FR_PART_PREPOSIT) && p->object1 == NULL))
	&& (p->frPartChoice & FR_PART_RELATIVE)) {
		TOKEN *verb = p;
		while(verb) {
			verb = SearchToken(FR_PART_VERB_UNCLEAR, verb->next);
			if(verb == NULL)	break;
			// 
			if(!IsAlwaysIntransitiveVerb(verb)) {
				TOKEN *altP = CopyCurrentTree(p, "Que 5");
				altP->frPart = FR_PART_RELATIVE_OBJECT_N;
				break;
			}
		}
		if(verb == NULL
		&&(prev->jpProp & JP_PROP_TIME)) {
			// Quatre jours que je marche. ̖ړIłȂĂA֌W㖼ɂȂ
			TOKEN *altP = CopyCurrentTree(p, "Que 6");
			altP->frPart = FR_PART_RELATIVE_OBJECT;	// RELATIVE_OBJECT_N;
		}
	}

	if(next
	&& next->frPart == FR_PART_SPECIAL_DE) {
		ChangeToQuestion(p, "que");
		return;
	}
	// ڑ <`Ƃ>
	if(IsObjectMatch(next, FR_PART_SENTENCE_NORMAL)
	&& (p->frPartChoice & FR_PART_VERB)) {
		DisconnectTOKEN(start, p);
		next->frPart = FR_PART_SENTENCE_QUE;
		if(next->subject)
			next->subject->jpEmphasis |= JP_EMPHASIS_GA;

		if(p->preposition)
			InsertTOKEN(prev, p->preposition);
	}
}

//
// 'o|'
// ^╛A֌W
void
Process_OU(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(next == NULL)	return;

	if(start == prev) {
		// 擪ɂƂƂ́A^㖼H
		ChangeToQuestion(p, "o|");
		return;
	}
	if(prev->frPart & FR_PART_COMBINE) {
		// Mais, o| sont neiges?
		TOKEN *altP = CopyCurrentTree(p, "Ou 1");
		altP->frPart = FR_PART_RELATIVE_ADVERB;
		ChangeToQuestion(p, "o|");
		return;
	}

	if((prev->frPart & FR_PART_NOUN)
	&& (prev->jpProp & (JP_PROP)(JP_PROP_TIME | JP_PROP_PLACE))
	&& (next->frPart & FR_PART_NOUN)) {		// ֌W
		p->frPart = FR_PART_RELATIVE_ADVERB;
		isChanged = TRUE;
		return;
	}
}

//
// 'plus'
// `eAr镛
// (ŕACombinePlusAdjectiveŏĂ)
//
void
Process_PLUS(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(prev
	&& IsObjectMatch(prev, FR_PART_ARTICLE_PRONOUN)
	&& (prev->frAttrib & FR_ATTRIB_SINGLE)) {	// le plus
		ChangeToProadverb(p, "plus");
		p->frAttrib = (FR_ATTRIB)(p->frAttrib | FR_ATTRIB_PLUS);
		return;
	}

	if(next == NULL
	|| IsObjectMatch(next, (FR_PART)(FR_PART_ADJECTIVE_ALL | FR_PART_ADVERB_ALL)) == NULL) {
		TOKEN	*altP = CopyCurrentTree(p, "Plus 1");
		ChangeToProadverb(altP, "plus");
		altP->frAttrib = (FR_ATTRIB)(altP->frAttrib | FR_ATTRIB_PLUS);
	}

	// elle n'est plus jeune.
	ChangeToAdverb(p, "plus");
}

//
// <s'>
// <se> or <si> GWI
void
Process_S(TOKEN *start, TOKEN *p)
{
	TOKEN	*altP = CopyCurrentTree(p, "S 1");

	ChangeToPronoun(p, "se");
	ChangeToPreposition(altP, "si");

	isChanged = TRUE;
}

//
// 'si'
// ڑA^⎌
void
Process_SI(TOKEN *start, TOKEN *p)
{
	if(start->next == p
	&& (p->next == NULL || p->next->frPart == FR_PART_SPECIAL_COMMA)) {
		// Si, j'ai une voiture.
		ChangeToInterjection(p, "si");
	} else {
		ChangeToPreposition(p, "si");
	}
	isChanged = TRUE;
}

//
// 'seulement'
// {́AATokenjmEmphasisɎ荞
//
void
Process_SEULEMENT(TOKEN *start, TOKEN *p)
{
	TOKEN	*next = p->next;
	if(next == NULL)	return;

	if(next->frPart & 
		(FR_PART)(FR_PART_NOUN | FR_PART_PREPOSIT | FR_PART_ADVERB | FR_PART_ADJECTIVE)) {
		DisconnectTOKEN(start, p);
		next->jpEmphasis |= JP_EMPHASIS_SEULEMENT;
	}
}

BOOL
IsAttribSingle(TOKEN *p) 
{
	if((p->frAttrib & FR_ATTRIB_SINGLE)
	&&  SearchToken(FR_PART_ARTICLE_DEFINIT, p->child))
		return(TRUE);

	return(FALSE);
}

static	JP_ADVERB	jpToutDeSuite[] = {
	JP_ADVERB("",	JP_KIND_KEIYODOSHI,	JP_PROP_TIME,	JP_PROP_ALL)
};
ADVERB adv_ToutDeSuite[] = { 
	"tout de suite",
	JPADVERB_DIC(jpToutDeSuite),
	NULL,
	NULL
};

CMP_TOKEN	pat_ToutDeSuite[] = {
	// tout de suite
	CMP_TOKEN( FR_PART_SPECIAL_TOUT,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_SPECIAL_DE,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NOUN_GENERAL,	"suite" ),
	CMP_TOKEN( FR_PART_NONE)
};

JP_PRONOUN	jpToutLeMonde[] = {
	JP_PRONOUN( FR_ATTRIB_ALL,	FR_ATTRIB_NONE,
				JP_PROP_ALL,	JP_PROP_NONE,
				NULL,
				"S",			JP_EMPHASIS_GA,	FR_PART_NOUN_POSSESIVE,
				FR_ATTRIB_IL,	JP_PROP_HUMAN,	JP_UNIT_HITO
	)
};
	

PRONOUN	pronoun_ToutLeMonde[] = {
	{ "tout le monde",		FR_ATTRIB_IL,	FR_SHORT_NONE, JPPRONOUN_DIC(jpToutLeMonde)	}
};

CMP_TOKEN	pat_ToutLeMonde[] = {
	// tout le monde.
	CMP_TOKEN( FR_PART_SPECIAL_TOUT,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NOUN_GENERAL,	"monde" ),
	CMP_TOKEN( FR_PART_NONE)
};

BOOL
HasPluralArticleDay(TOKEN *p)
{
	TOKEN	*article = SearchToken(FR_PART_ARTICLE_DEFINIT, p->child);

	if(  article == NULL
	|| !(article->frAttrib & FR_ATTRIB_PLURAL))
		return(FALSE);
	if(IsDayName(p))
		return(TRUE);

	return(FALSE);
}

BOOL
HasRelativeQue(TOKEN *p)
{
	if(SearchToken(FR_PART_RELATIVE_OBJECT, p->child))
		return(TRUE);

	return(FALSE);
}

static	JP_PROADJECTIVE	jpadj_TousLesDays[] = {
	JP_PROADJECTIVE(
		FR_PART_ADJECTIVE_DEMONSTRATIVE,
		"T",		JP_KIND_NONE,
		JP_PROP_CONDITION)
};
PROADJECTIVE	proadj_TousLesDays[] = {
	{ "tous",	FR_ATTRIB_NONE,	FR_CHANGE_NONE, JPPROADJ_DIC(jpadj_TousLesDays)	},
};

CMP_TOKEN	pat_TousLesDays[] = {
	// tous les dimanches. -> Tj
	CMP_TOKEN( FR_PART_SPECIAL_TOUT,	JP_PROP_NONE,	NULL	),
	CMP_TOKEN( FR_PART_NOUN_GENERAL,	JP_PROP_NONE,	HasPluralArticleDay),
	CMP_TOKEN( FR_PART_NONE)
};

CMP_TOKEN	pat_ToutNouns[] = {
	// tout jours. -> ǂ̓()
	CMP_TOKEN( FR_PART_SPECIAL_TOUT,		JP_PROP_NONE,	NULL	),
	CMP_TOKEN( FR_PART_NOUN_GENERAL,		JP_PROP_NONE,	HasNoArticlePossesive),
	CMP_TOKEN( FR_PART_NONE)
};

CMP_TOKEN	pat_ToutLeNoun[] = {
	// tout la journ{e. -> ̑S()
	CMP_TOKEN( FR_PART_SPECIAL_TOUT,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NOUN_GENERAL,		JP_PROP_NONE,	IsAttribSingle),
	CMP_TOKEN( FR_PART_NONE)
};
CMP_TOKEN	pat_ToutLeNouns[] = {
	// tout les jours. -> SĂ̈()
	CMP_TOKEN( FR_PART_SPECIAL_TOUT,		JP_PROP_NONE,	NULL	),
	CMP_TOKEN( FR_PART_NOUN_GENERAL,		JP_PROP_NONE,	HasPluralArticlePossesive),
	CMP_TOKEN( FR_PART_NONE)
};

CMP_TOKEN	pat_ToutCeQue[] = {
	// tout ce que je as observ{. -> Nώ@Ƃ̑S
	CMP_TOKEN( FR_PART_SPECIAL_TOUT,	JP_PROP_NONE,	NULL	),
	CMP_TOKEN( FR_PART_NOUN_IMPERSONAL,JP_PROP_NONE,	HasRelativeQue,	"ce"),
	CMP_TOKEN( FR_PART_NONE)
};

CMP_TOKEN	pat_TousLesNum[] = {
	// tous les deux. -> lE
	CMP_TOKEN( FR_PART_SPECIAL_TOUT,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_ARTICLE_DEFINIT,	JP_PROP_NONE,	IsAttribPlural),
	CMP_TOKEN( FR_PART_NUMETRIC_NUMBER,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NONE)
};


//
// <TOUT>
// s㖼A`eA
void
Process_TOUT(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	if(IsPatternMatch(pat_ToutDeSuite, p)) {
		DisconnectTOKEN(start, p->next->next);
		DisconnectTOKEN(start, p->next);
		ChangeToAdverb(p, adv_ToutDeSuite);
	} else if(IsPatternMatch(pat_ToutLeMonde, p)) {
//		DisconnectTOKEN(start, p->next->next);
		DisconnectTOKEN(start, p->next);
		ChangeToPronoun(p, pronoun_ToutLeMonde);
	} else if(IsPatternMatch(pat_TousLesDays, p)) {
		TOKEN	*noun = p->next;
		TOKEN	*article = SearchToken(FR_PART_ARTICLE_DEFINIT, noun->child);
		if(article)	article->prtControl = PRT_CONTROL_DISABLE;	// 
		ChangeToProadjective(p, proadj_TousLesDays);
		AttachAdjective(start, noun, p, FR_LOCATION_FRONT);
	} else if(IsPatternMatch(pat_ToutNouns, p)) {
		if(prev->frPart & FR_PART_VERB) {
			// Nous sommes tout Japonais. B<݂>{lł
			ChangeToProadverb(p, *(char **)p->what);
		} else {
			TOKEN	*noun = p->next;
			ChangeToProadjective(p, *(char **)p->what);
			DisconnectTOKEN(start, p);
			AttachAdjective(start, noun, p, FR_LOCATION_FRONT);
			noun->jpEmphasis = JP_EMPHASIS_MO;
		}
	} else if(IsPatternMatch(pat_ToutNouns, p)) {
		TOKEN	*noun = p->next;
		DisconnectTOKEN(start, noun);
		AddChildTOKEN(p, noun);
		SelectJpNoun(NULL, noun, noun, JP_PROP_ALL);
		p->jpProp = noun->jpProp | JP_PROP_VOLUME;
	} else if(IsPatternMatch(pat_ToutCeQue , p)) {
	// tout ce que je as observ{. -> Nώ@Ƃ̑S
		TOKEN	*noun = p->next;
		ChangeToPronoun(p, *(char **)p->what);
		DisconnectTOKEN(start, noun);
		AddChildTOKEN(p, noun);
		SelectJpNoun(NULL, p, p, JP_PROP_ALL);
		p->jpProp = noun->jpProp | JP_PROP_VOLUME;
	} else if(IsPatternMatch(pat_ToutLeNoun, p)) {
		TOKEN	*noun = p->next;
		ChangeToPronoun(p, *(char **)p->what);
		DisconnectTOKEN(start, noun);
		AddChildTOKEN(p, noun);
		SelectJpNoun(NULL, p, p, JP_PROP_ALL);
		p->jpProp = noun->jpProp | JP_PROP_VOLUME;
	} else if(IsPatternMatch(pat_ToutLeNouns, p)) {
		TOKEN	*noun = p->next;
		TOKEN	*article = SearchToken(FR_PART_ARTICLE_DEFINIT, noun->child);
		if(article == NULL)
			article = SearchToken(FR_PART_ADJECTIVE_POSSESIVE, noun->child);
		if(article)	article->prtControl = PRT_CONTROL_DISABLE;	// 
		ChangeToAdjective(p, *(char **)p->what);
		AttachAdjective(start, noun, p, FR_LOCATION_FRONT);
//		DisconnectTOKEN(start, p);
//		AddChildTOKEN(noun, p);
	} else if(IsPatternMatch(pat_TousLesNum, p)) {
		TOKEN	*article = p->next;
		TOKEN	*num = article->next;
		DisconnectTOKEN(start, num);
		DisconnectTOKEN(start, article);
		p->value = num->value;
		ChangeToProadverb(p, *(char **)p->what);
	} else if(p->next
		&& IsTokenFrench(p->next, "ce")) {
		// ςȌ𑝂₳Ȃ
		return;

	} else if(p->frPartChoice & FR_PART_NOUN) {
		TOKEN	*altP = CopyCurrentTree(p, "Tout 1", FR_PART_NOUN);
		ChangeToPronoun(p, *(char **)p->what);
	} else if(p->frPartChoice & FR_PART_ADVERB) {
		// Nous sommes tout Japonais.
		TOKEN	*altP = CopyCurrentTree(p, "Tout 3", FR_PART_ADVERB);
		ChangeToProadverb(p, *(char **)p->what);
	}
}

//
// FR_PART_SPECIAL ͌ʂɕϊ
//
void
ConvertSpecialWord(TOKEN *p, FR_PART frPart)
{
	switch(p->frPart) {
	case FR_PART_SPECIAL_DE:	// s芥AAOu(inf𓱂)A`eƂȂAے芥
		if(frPart == FR_PART_PREPOSIT_DE) {
			TOKEN	*next = p->next;
			ChangeToPreposition(p, "de");
			p->which  = (void *)&dic_jpr_de[0];
			if(!IsObjectMatch(next, FR_PART_NOUN_ALL))
				PrintInternalError( "Internal Error <ConvertSpecialWord> -2-\n");
			if(SelectJpPreposition1(p, next)) {
				DisconnectTOKEN(p, next);
				p->object1 = next;
			}
		} else if(frPart == FR_PART_PREPOSIT_DE_INF) {
			ChangeToPreposition(p, dic_DeInf);
		} else if(frPart & FR_PART_ADJECTIVE) {
			PrintInternalError( "Internal Error <ConverSpecialWord 2>\n");
		} else goto Error;
		break;
	case FR_PART_SPECIAL_EN:	// OuA㖼Aen + WFfBt
		if(frPart & FR_PART_NOUN) {
			ChangeToObjectPronoun(p, "en");
			p->frPart = frPart;	// (FR_PART)(FR_PART_NOUN_OBJECT_D | FR_PART_NOUN_OBJECT_I);
		} else if(frPart == FR_PART_PREPOSIT_DE) {
			ChangeToPreposition(p, "de");
		} else goto Error;
		break;
	case FR_PART_SPECIAL_LEUR:
		goto Error;
	default:
		return;
	}
	isChanged = TRUE;
	return;
Error:
	PrintInternalError( "Internal Error <ConvertSpecialWord>");
}

//
// 㖼 y, en<>
//
JP_PRONOUN	dic_IndicatingNoun[] = {
	JP_PRONOUN(	FR_ATTRIB_ALL,	FR_ATTRIB_NONE,
		JP_PROP_ALL,	JP_PROP_NONE,
		NULL,
		"",			JP_EMPHASIS_NONE,	FR_PART_NOUN_OBJECT_BOTH,
		FR_ATTRIB_ALL,	JP_PROP_ALL,		JP_UNIT_TSU)
};

PRONOUN	dic_indicationg_noun = 
{
	"㖼[",
	FR_ATTRIB_ALL,	FR_SHORT_NONE,
	JPPRONOUN_DIC(dic_IndicatingNoun)
};
//
// 㖼 y, en<>		j'vais
//
JP_PRONOUN	dic_IndicatingNounPlace[] = {
	JP_PRONOUN(	FR_ATTRIB_ALL,	FR_ATTRIB_NONE,
		JP_PROP_ALL,	JP_PROP_NONE,
		NULL,
		"",			JP_EMPHASIS_NONE,	FR_PART_NOUN_OBJECT_I,
		FR_ATTRIB_ALL,	JP_PROP_ALL,		JP_UNIT_TSU
	)
};

PRONOUN	dic_indicationg_noun_place = 
{
	"㖼[",
	FR_ATTRIB_ALL,	FR_SHORT_NONE,
	JPPRONOUN_DIC(dic_IndicatingNounPlace)
};

//
// en, yi㖼jde@Ŏ󂯂ꍇ
//
void
ChangeProperObject(TOKEN *p, FR_PART frPart, JP_PROP jpProp)
{
	if(p->frPart & FR_PART_SPECIAL) {
		ConvertSpecialWord(p, frPart);
	} else if(frPart == FR_PART_PREPOSIT_DE
		&& IsTokenFrench(p, "en")) {
			ChangeToPreposition(p, "de");
			TOKEN *noun = PutNullNoun(FR_PART_NOUN_OBJECT_BOTH, PRT_CONTROL_ENABLE);
			ChangeToPronoun(noun, &dic_indicationg_noun);
			CombinePrepositionObject(p, p, noun);
	} else if(frPart == FR_PART_PREPOSIT_A
		&& p->frPart == FR_PART_ADVERB_Y) {
			ChangeToPreposition(p, "@");
			TOKEN *noun = PutNullNoun(FR_PART_NOUN_OBJECT_BOTH, PRT_CONTROL_ENABLE);
			p->jpProp = jpProp;
			if((jpProp & JP_PROP_PLACE) && jpProp != JP_PROP_ALL)
				ChangeToPronoun(noun, &dic_indicationg_noun_place);
			else
				ChangeToPronoun(noun, &dic_indicationg_noun);
			CombinePrepositionObject(p, p, noun);
	}
}

//
// ʂ͂ĂȂ
//
void
ProcessSpecialWord2(TOKEN *start)
{
	TOKEN	*prev = start;
	TOKEN	*p;

	for(p = start->next; p; p = p->next) {
		switch(p->frPart) {
		case FR_PART_SPECIAL_AUSSI:		Process2_AUSSI(start, prev, p);	break;
		case FR_PART_SPECIAL_COMMA:		Process2_COMMA(start, prev, p);				break;
		case FR_PART_SPECIAL_DE:		Process2_DE(start, prev, p);		break;
//		case FR_PART_SPECIAL_DES:		Process2_DES(start, prev, p);	break;
		case FR_PART_SPECIAL_ESTCEQUE:	Process2_EstCeQue(start, prev, p);	break;
		}
		prev = p;
	}
}


//
// aussi
//
void
Process2_AUSSI(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;
	
	if(prev
	&& prev->frPart & FR_PART_NOUN) {
		prev->jpEmphasis |= JP_EMPHASIS_MO;
		DisconnectTOKEN(start, p);
	}
	else if( next
	&& (next->frPart & FR_PART_ADVERB_ADJECTIVE)) {
		next->frAttrib = (FR_ATTRIB)(next->frAttrib | FR_ATTRIB_AUSSI);
		DisconnectTOKEN(start, p);
	}
}

void
Process2_COMMA(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(next == NULL)	return;

	if((prev->frPart & FR_PART_COMBINE)
		&& prev->object2 == NULL) {
		// Mais, o| est les neiges d'antan?
		DisconnectTOKEN(start, p);
		next->punctuation = FR_PUNCT_COMMA;
	} else if((next->frPart & FR_PART_COMBINE)
		&& next->object1 == NULL) {
		if(next->object2 != NULL) {
			// , mais SV,	, car SV
			DisconnectTOKEN(start, p);
			next->punctuation = FR_PUNCT_COMMA;
		}
	}
}

CMP_TOKEN	pat_DeSentence1[] = {
	// d'une main tremblente, il a ouvert la bo^te.\j'
	CMP_TOKEN( FR_PART_SPECIAL_DE,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NOUN_ALL,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_SPECIAL_COMMA,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_SENTENCE_ALL,	JP_PROP_NONE,	IsLastToken),
	CMP_TOKEN( FR_PART_NONE)
};

CMP_TOKEN	pat_DeSentence2[] = {
	// d'une main tremblente il a ouvert la bo^te.'
	CMP_TOKEN( FR_PART_SPECIAL_DE,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NOUN_ALL,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_SENTENCE_ALL,	JP_PROP_NONE,	IsLastToken),
	CMP_TOKEN( FR_PART_NONE)
};

CMP_TOKEN	pat_DeSentence3[] = {
	// On peut voir la montagne de la fenetre.
	CMP_TOKEN( FR_PART_SENTENCE_ALL,	JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_SPECIAL_DE,		JP_PROP_NONE,	NULL),
	CMP_TOKEN( FR_PART_NOUN_ALL,		JP_PROP_NONE,	IsLastToken	),
	CMP_TOKEN( FR_PART_NONE)
};

//
// 'de'îQj
//  + `e +  ?,	? ے芥H
void
Process2_DE(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	if(start->next == p) {
		if(IsPatternMatch(pat_DeSentence1, p)
		|| IsPatternMatch(pat_DeSentence2, p))
			ChangeToPreposition(p, "de");
	} else if(IsPatternMatch(pat_DeSentence3, prev)) {
		ChangeToPreposition(p, "de");
	}
}

//
// 'des'(̂Q)
// s芥H
void
Process2_DES(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	TOKEN	*next = p->next;

	if(next
	&& IsObjectMatch(next, FR_PART_NOUN_GENERAL)
	&& (next->frAttrib & FR_ATTRIB_PLURAL)
	// ܂AĂȂ
	&& SearchToken(FR_PART_ARTICLE_ALL, next->child) == NULL) {
		// 'des' petits livres -> 'de' petits livereŝ͂
		if(SearchToken(FR_PART_ADJECTIVE_GENERAL_F, next->child) == NULL
		&& (p->frPartChoice & FR_PART_ARTICLE)) {
			// s芥
			if(!(next->jpProp & JP_PROP_PARTIAL))	// ⓚp
				CopyCurrentTree(p, "Des 1", FR_PART_ARTICLE);
			ChangeToArticle(p, "des");
		} else if(p->frPartChoice & FR_PART_PREPOSIT) {
			if(prev
			// etrěɂ́Ak񊥎Ȃ悤ȋC...
			&& !strcmp(GetTokenFrench(prev), "]tre")) {
				currentTree->prtControl = PRT_CONTROL_DISABLE;
			} else {
				// k񊥎 ( des -> de + les )
				PutToken(FR_PART_ARTICLE_DEFINIT,
					(FR_ATTRIB)(FR_ATTRIB_BOTH_SEX | FR_ATTRIB_PLURAL | FR_ATTRIB_LEVEL3),
					JP_PROP_NONE, NULL);
				InsertTOKEN(p, lastToken);
				ChangeToSpecial(p, "de");
				ChangeToArticle(lastToken, "les");
			}
		}
	}
}

//
//
//
void
Process2_EstCeQue(TOKEN *start, TOKEN *prev, TOKEN *p)
{
	if(p->next == NULL
	|| !(currentTree->punctuation & FR_PUNCT_QUESTION)) return;

	if((p->next->frPart & FR_PART_NOUN)
	&&  p->next->next
	&& (p->next->next->frPart & FR_PART_VERB)) {
		p->next->next->jpProp |= JP_PROP_QUESTION;
		DisconnectTOKEN(start, p);
	} else if(IsObjectMatch(p->next, FR_PART_SENTENCE_ALL)
	&& !(p->next->jpProp & JP_PROP_QUESTION)) {
		TOKEN	*sentence = p->next;
		if(sentence->object2)
			sentence->object2->jpProp |= JP_PROP_QUESTION;	// ꍇ
		else
			p->next->jpProp |= JP_PROP_QUESTION;
		DisconnectTOKEN(start, p);
	}
}